package com.kalixia.intellij.plugins.je.browser.actions;

import com.kalixia.intellij.plugins.je.browser.JEBrowserPanel;
import com.kalixia.intellij.plugins.je.browser.tree.StoreTreeNode;
import com.sleepycat.je.DatabaseException;
import org.jdesktop.swingx.JXErrorPane;
import org.jdesktop.swingx.error.ErrorInfo;
import org.jdesktop.swingx.error.ErrorLevel;
import javax.swing.*;
import javax.swing.tree.TreePath;
import java.awt.event.ActionEvent;

public class OpenStoreAction extends AbstractAction {
    private JEBrowserPanel browser;
    private JTree storesTree;

    public OpenStoreAction(JEBrowserPanel browser) {
        super("Open store");
        this.browser = browser;
        this.storesTree = browser.getStoresTree();
    }

    public void actionPerformed(ActionEvent event) {
        TreePath path = storesTree.getSelectionPath();
        StoreTreeNode node = (StoreTreeNode) path.getLastPathComponent();
        try {
            browser.openStore(node);
        } catch (Exception e) {
            JXErrorPane.showDialog(browser.getRootComponent(), new ErrorInfo(
                    "Open Berkeley DB (Java Edition) store",
                    e.getMessage(),
                    null, "ERROR", e, ErrorLevel.SEVERE, null)
            );
        }
    }
}