package com.kalixia.intellij.plugins.je.ui;

import com.intellij.openapi.components.ProjectComponent;
import com.intellij.openapi.fileChooser.FileChooserDescriptor;
import com.intellij.openapi.fileChooser.FileChooserDescriptorFactory;
import com.intellij.openapi.fileChooser.FileChooserDialog;
import com.intellij.openapi.fileChooser.FileChooserFactory;
import com.intellij.openapi.project.Project;
import com.intellij.openapi.project.ProjectManager;
import com.intellij.openapi.wm.ex.WindowManagerEx;
import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;
import javax.swing.*;
import java.awt.event.ActionEvent;

public class DirectoryChooser extends JPanel implements ProjectComponent {
    private JTextField tfDirectory;
    private JButton btnChoose;
    private Project project;

    public void projectOpened() {}

    public void projectClosed() {}

    @NonNls @NotNull
    public String getComponentName() {
        return "Directory Chooser";
    }

    public void initComponent() {
        final Project project = ProjectManager.getInstance().getDefaultProject();
        FileChooserDescriptor fileChooserDescriptor = FileChooserDescriptorFactory.createSingleFolderDescriptor();
        final FileChooserDialog chooser = FileChooserFactory.getInstance().createFileChooser(fileChooserDescriptor,
                WindowManagerEx.getInstanceEx().suggestParentWindow(project));

        tfDirectory = new JTextField();
        tfDirectory.setEditable(false);

        btnChoose = new JButton("...");
        btnChoose.setAction(new AbstractAction() {
            public void actionPerformed(ActionEvent event) {
                chooser.choose(project.getBaseDir(), project);
            }
        });

        add(tfDirectory);
        add(btnChoose);
    }

    public void disposeComponent() {}
}
